/*
 * generated by Xtext 2.11.0
 */
package com.mncml.implementation.pogo.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.CrossReference;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder.AbstractGrammarElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class SimulatorDslGrammarAccess extends AbstractGrammarElementFinder {
	
	public class TangoSimLibElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.TangoSimLib");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cTangoSimLibAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cTangoSimLibKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cForKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Assignment cRefferedPogoDeviceClassAssignment_3 = (Assignment)cGroup.eContents().get(3);
		private final CrossReference cRefferedPogoDeviceClassPogoDeviceClassCrossReference_3_0 = (CrossReference)cRefferedPogoDeviceClassAssignment_3.eContents().get(0);
		private final RuleCall cRefferedPogoDeviceClassPogoDeviceClassQualifiedNameParserRuleCall_3_0_1 = (RuleCall)cRefferedPogoDeviceClassPogoDeviceClassCrossReference_3_0.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_4 = (Keyword)cGroup.eContents().get(4);
		private final Group cGroup_5 = (Group)cGroup.eContents().get(5);
		private final Keyword cDataSimulationsKeyword_5_0 = (Keyword)cGroup_5.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_5_1 = (Keyword)cGroup_5.eContents().get(1);
		private final Group cGroup_5_2 = (Group)cGroup_5.eContents().get(2);
		private final Assignment cDataSimulationsAssignment_5_2_0 = (Assignment)cGroup_5_2.eContents().get(0);
		private final RuleCall cDataSimulationsDataSimulationParserRuleCall_5_2_0_0 = (RuleCall)cDataSimulationsAssignment_5_2_0.eContents().get(0);
		private final Group cGroup_5_2_1 = (Group)cGroup_5_2.eContents().get(1);
		private final Keyword cCommaKeyword_5_2_1_0 = (Keyword)cGroup_5_2_1.eContents().get(0);
		private final Assignment cDataSimulationsAssignment_5_2_1_1 = (Assignment)cGroup_5_2_1.eContents().get(1);
		private final RuleCall cDataSimulationsDataSimulationParserRuleCall_5_2_1_1_0 = (RuleCall)cDataSimulationsAssignment_5_2_1_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_5_3 = (Keyword)cGroup_5.eContents().get(3);
		private final Group cGroup_6 = (Group)cGroup.eContents().get(6);
		private final Keyword cBehavioursKeyword_6_0 = (Keyword)cGroup_6.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_6_1 = (Keyword)cGroup_6.eContents().get(1);
		private final Group cGroup_6_2 = (Group)cGroup_6.eContents().get(2);
		private final Assignment cCommandSimulationsAssignment_6_2_0 = (Assignment)cGroup_6_2.eContents().get(0);
		private final RuleCall cCommandSimulationsCommandSimulationParserRuleCall_6_2_0_0 = (RuleCall)cCommandSimulationsAssignment_6_2_0.eContents().get(0);
		private final Group cGroup_6_2_1 = (Group)cGroup_6_2.eContents().get(1);
		private final Keyword cCommaKeyword_6_2_1_0 = (Keyword)cGroup_6_2_1.eContents().get(0);
		private final Assignment cCommandSimulationsAssignment_6_2_1_1 = (Assignment)cGroup_6_2_1.eContents().get(1);
		private final RuleCall cCommandSimulationsCommandSimulationParserRuleCall_6_2_1_1_0 = (RuleCall)cCommandSimulationsAssignment_6_2_1_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_6_3 = (Keyword)cGroup_6.eContents().get(3);
		private final Group cGroup_7 = (Group)cGroup.eContents().get(7);
		private final Keyword cOverrideKeyword_7_0 = (Keyword)cGroup_7.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_7_1 = (Keyword)cGroup_7.eContents().get(1);
		private final Group cGroup_7_2 = (Group)cGroup_7.eContents().get(2);
		private final Assignment cOverrideClassAssignment_7_2_0 = (Assignment)cGroup_7_2.eContents().get(0);
		private final RuleCall cOverrideClassOverrideClassParserRuleCall_7_2_0_0 = (RuleCall)cOverrideClassAssignment_7_2_0.eContents().get(0);
		private final Keyword cCommaKeyword_7_2_1 = (Keyword)cGroup_7_2.eContents().get(1);
		private final Assignment cOverrideClassAssignment_7_2_2 = (Assignment)cGroup_7_2.eContents().get(2);
		private final RuleCall cOverrideClassOverrideClassParserRuleCall_7_2_2_0 = (RuleCall)cOverrideClassAssignment_7_2_2.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_7_3 = (Keyword)cGroup_7.eContents().get(3);
		private final Keyword cRightCurlyBracketKeyword_8 = (Keyword)cGroup.eContents().get(8);
		
		//TangoSimLib:
		//	{TangoSimLib}
		//	'TangoSimLib' 'for' refferedPogoDeviceClass=[pogoDsl::PogoDeviceClass|QualifiedName]?
		//	'{' ('dataSimulations' '{' (dataSimulations+=DataSimulation (',' dataSimulations+=DataSimulation)*)?
		//	'}')? ('behaviours' '{' (commandSimulations+=CommandSimulation ("," commandSimulations+=CommandSimulation*))?
		//	'}')? ('override' '{' (overrideClass+=OverrideClass ',' overrideClass+=OverrideClass*)?
		//	'}')?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//{TangoSimLib} 'TangoSimLib' 'for' refferedPogoDeviceClass=[pogoDsl::PogoDeviceClass|QualifiedName]? '{'
		//('dataSimulations' '{' (dataSimulations+=DataSimulation (',' dataSimulations+=DataSimulation)*)? '}')? ('behaviours'
		//'{' (commandSimulations+=CommandSimulation ("," commandSimulations+=CommandSimulation*))? '}')? ('override' '{'
		//(overrideClass+=OverrideClass ',' overrideClass+=OverrideClass*)? '}')? '}'
		public Group getGroup() { return cGroup; }
		
		//{TangoSimLib}
		public Action getTangoSimLibAction_0() { return cTangoSimLibAction_0; }
		
		//'TangoSimLib'
		public Keyword getTangoSimLibKeyword_1() { return cTangoSimLibKeyword_1; }
		
		//'for'
		public Keyword getForKeyword_2() { return cForKeyword_2; }
		
		//refferedPogoDeviceClass=[pogoDsl::PogoDeviceClass|QualifiedName]?
		public Assignment getRefferedPogoDeviceClassAssignment_3() { return cRefferedPogoDeviceClassAssignment_3; }
		
		//[pogoDsl::PogoDeviceClass|QualifiedName]
		public CrossReference getRefferedPogoDeviceClassPogoDeviceClassCrossReference_3_0() { return cRefferedPogoDeviceClassPogoDeviceClassCrossReference_3_0; }
		
		//QualifiedName
		public RuleCall getRefferedPogoDeviceClassPogoDeviceClassQualifiedNameParserRuleCall_3_0_1() { return cRefferedPogoDeviceClassPogoDeviceClassQualifiedNameParserRuleCall_3_0_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_4() { return cLeftCurlyBracketKeyword_4; }
		
		//('dataSimulations' '{' (dataSimulations+=DataSimulation (',' dataSimulations+=DataSimulation)*)? '}')?
		public Group getGroup_5() { return cGroup_5; }
		
		//'dataSimulations'
		public Keyword getDataSimulationsKeyword_5_0() { return cDataSimulationsKeyword_5_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_5_1() { return cLeftCurlyBracketKeyword_5_1; }
		
		//(dataSimulations+=DataSimulation (',' dataSimulations+=DataSimulation)*)?
		public Group getGroup_5_2() { return cGroup_5_2; }
		
		//dataSimulations+=DataSimulation
		public Assignment getDataSimulationsAssignment_5_2_0() { return cDataSimulationsAssignment_5_2_0; }
		
		//DataSimulation
		public RuleCall getDataSimulationsDataSimulationParserRuleCall_5_2_0_0() { return cDataSimulationsDataSimulationParserRuleCall_5_2_0_0; }
		
		//(',' dataSimulations+=DataSimulation)*
		public Group getGroup_5_2_1() { return cGroup_5_2_1; }
		
		//','
		public Keyword getCommaKeyword_5_2_1_0() { return cCommaKeyword_5_2_1_0; }
		
		//dataSimulations+=DataSimulation
		public Assignment getDataSimulationsAssignment_5_2_1_1() { return cDataSimulationsAssignment_5_2_1_1; }
		
		//DataSimulation
		public RuleCall getDataSimulationsDataSimulationParserRuleCall_5_2_1_1_0() { return cDataSimulationsDataSimulationParserRuleCall_5_2_1_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_5_3() { return cRightCurlyBracketKeyword_5_3; }
		
		//('behaviours' '{' (commandSimulations+=CommandSimulation ("," commandSimulations+=CommandSimulation*))? '}')?
		public Group getGroup_6() { return cGroup_6; }
		
		//'behaviours'
		public Keyword getBehavioursKeyword_6_0() { return cBehavioursKeyword_6_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_6_1() { return cLeftCurlyBracketKeyword_6_1; }
		
		//(commandSimulations+=CommandSimulation ("," commandSimulations+=CommandSimulation*))?
		public Group getGroup_6_2() { return cGroup_6_2; }
		
		//commandSimulations+=CommandSimulation
		public Assignment getCommandSimulationsAssignment_6_2_0() { return cCommandSimulationsAssignment_6_2_0; }
		
		//CommandSimulation
		public RuleCall getCommandSimulationsCommandSimulationParserRuleCall_6_2_0_0() { return cCommandSimulationsCommandSimulationParserRuleCall_6_2_0_0; }
		
		//"," commandSimulations+=CommandSimulation*
		public Group getGroup_6_2_1() { return cGroup_6_2_1; }
		
		//","
		public Keyword getCommaKeyword_6_2_1_0() { return cCommaKeyword_6_2_1_0; }
		
		//commandSimulations+=CommandSimulation*
		public Assignment getCommandSimulationsAssignment_6_2_1_1() { return cCommandSimulationsAssignment_6_2_1_1; }
		
		//CommandSimulation
		public RuleCall getCommandSimulationsCommandSimulationParserRuleCall_6_2_1_1_0() { return cCommandSimulationsCommandSimulationParserRuleCall_6_2_1_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_6_3() { return cRightCurlyBracketKeyword_6_3; }
		
		//('override' '{' (overrideClass+=OverrideClass ',' overrideClass+=OverrideClass*)? '}')?
		public Group getGroup_7() { return cGroup_7; }
		
		//'override'
		public Keyword getOverrideKeyword_7_0() { return cOverrideKeyword_7_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_7_1() { return cLeftCurlyBracketKeyword_7_1; }
		
		//(overrideClass+=OverrideClass ',' overrideClass+=OverrideClass*)?
		public Group getGroup_7_2() { return cGroup_7_2; }
		
		//overrideClass+=OverrideClass
		public Assignment getOverrideClassAssignment_7_2_0() { return cOverrideClassAssignment_7_2_0; }
		
		//OverrideClass
		public RuleCall getOverrideClassOverrideClassParserRuleCall_7_2_0_0() { return cOverrideClassOverrideClassParserRuleCall_7_2_0_0; }
		
		//','
		public Keyword getCommaKeyword_7_2_1() { return cCommaKeyword_7_2_1; }
		
		//overrideClass+=OverrideClass*
		public Assignment getOverrideClassAssignment_7_2_2() { return cOverrideClassAssignment_7_2_2; }
		
		//OverrideClass
		public RuleCall getOverrideClassOverrideClassParserRuleCall_7_2_2_0() { return cOverrideClassOverrideClassParserRuleCall_7_2_2_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_7_3() { return cRightCurlyBracketKeyword_7_3; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_8() { return cRightCurlyBracketKeyword_8; }
	}
	public class OverrideClassElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.OverrideClass");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cOverrideClassAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cOverrideClassKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Keyword cNameKeyword_3_0 = (Keyword)cGroup_3.eContents().get(0);
		private final Assignment cNameAssignment_3_1 = (Assignment)cGroup_3.eContents().get(1);
		private final RuleCall cNameSTRINGTerminalRuleCall_3_1_0 = (RuleCall)cNameAssignment_3_1.eContents().get(0);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cModule_directoryKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cModule_directoryAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final RuleCall cModule_directoryEStringParserRuleCall_4_1_0 = (RuleCall)cModule_directoryAssignment_4_1.eContents().get(0);
		private final Group cGroup_5 = (Group)cGroup.eContents().get(5);
		private final Keyword cModule_nameKeyword_5_0 = (Keyword)cGroup_5.eContents().get(0);
		private final Assignment cModule_nameAssignment_5_1 = (Assignment)cGroup_5.eContents().get(1);
		private final RuleCall cModule_nameEStringParserRuleCall_5_1_0 = (RuleCall)cModule_nameAssignment_5_1.eContents().get(0);
		private final Group cGroup_6 = (Group)cGroup.eContents().get(6);
		private final Keyword cClass_nameKeyword_6_0 = (Keyword)cGroup_6.eContents().get(0);
		private final Assignment cClass_nameAssignment_6_1 = (Assignment)cGroup_6.eContents().get(1);
		private final RuleCall cClass_nameEStringParserRuleCall_6_1_0 = (RuleCall)cClass_nameAssignment_6_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_7 = (Keyword)cGroup.eContents().get(7);
		
		//OverrideClass:
		//	{OverrideClass}
		//	'OverrideClass' '{' ('name' name=STRING)? ('module_directory' module_directory=EString)? ('module_name'
		//	module_name=EString)? ('class_name' class_name=EString)?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//{OverrideClass} 'OverrideClass' '{' ('name' name=STRING)? ('module_directory' module_directory=EString)? ('module_name'
		//module_name=EString)? ('class_name' class_name=EString)? '}'
		public Group getGroup() { return cGroup; }
		
		//{OverrideClass}
		public Action getOverrideClassAction_0() { return cOverrideClassAction_0; }
		
		//'OverrideClass'
		public Keyword getOverrideClassKeyword_1() { return cOverrideClassKeyword_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//('name' name=STRING)?
		public Group getGroup_3() { return cGroup_3; }
		
		//'name'
		public Keyword getNameKeyword_3_0() { return cNameKeyword_3_0; }
		
		//name=STRING
		public Assignment getNameAssignment_3_1() { return cNameAssignment_3_1; }
		
		//STRING
		public RuleCall getNameSTRINGTerminalRuleCall_3_1_0() { return cNameSTRINGTerminalRuleCall_3_1_0; }
		
		//('module_directory' module_directory=EString)?
		public Group getGroup_4() { return cGroup_4; }
		
		//'module_directory'
		public Keyword getModule_directoryKeyword_4_0() { return cModule_directoryKeyword_4_0; }
		
		//module_directory=EString
		public Assignment getModule_directoryAssignment_4_1() { return cModule_directoryAssignment_4_1; }
		
		//EString
		public RuleCall getModule_directoryEStringParserRuleCall_4_1_0() { return cModule_directoryEStringParserRuleCall_4_1_0; }
		
		//('module_name' module_name=EString)?
		public Group getGroup_5() { return cGroup_5; }
		
		//'module_name'
		public Keyword getModule_nameKeyword_5_0() { return cModule_nameKeyword_5_0; }
		
		//module_name=EString
		public Assignment getModule_nameAssignment_5_1() { return cModule_nameAssignment_5_1; }
		
		//EString
		public RuleCall getModule_nameEStringParserRuleCall_5_1_0() { return cModule_nameEStringParserRuleCall_5_1_0; }
		
		//('class_name' class_name=EString)?
		public Group getGroup_6() { return cGroup_6; }
		
		//'class_name'
		public Keyword getClass_nameKeyword_6_0() { return cClass_nameKeyword_6_0; }
		
		//class_name=EString
		public Assignment getClass_nameAssignment_6_1() { return cClass_nameAssignment_6_1; }
		
		//EString
		public RuleCall getClass_nameEStringParserRuleCall_6_1_0() { return cClass_nameEStringParserRuleCall_6_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_7() { return cRightCurlyBracketKeyword_7; }
	}
	public class QualifiedNameElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.QualifiedName");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final RuleCall cIDTerminalRuleCall_0 = (RuleCall)cGroup.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Keyword cFullStopKeyword_1_0 = (Keyword)cGroup_1.eContents().get(0);
		private final RuleCall cIDTerminalRuleCall_1_1 = (RuleCall)cGroup_1.eContents().get(1);
		
		//QualifiedName:
		//	ID ('.' ID)*;
		@Override public ParserRule getRule() { return rule; }
		
		//ID ('.' ID)*
		public Group getGroup() { return cGroup; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_0() { return cIDTerminalRuleCall_0; }
		
		//('.' ID)*
		public Group getGroup_1() { return cGroup_1; }
		
		//'.'
		public Keyword getFullStopKeyword_1_0() { return cFullStopKeyword_1_0; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_1_1() { return cIDTerminalRuleCall_1_1; }
	}
	public class SimulationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.Simulation");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cGaussianSlewLimitedParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cConstantQuantityParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		private final RuleCall cDeterministicSignalParserRuleCall_2 = (RuleCall)cAlternatives.eContents().get(2);
		private final RuleCall cRuntimeSpecifiedWaveformParserRuleCall_3 = (RuleCall)cAlternatives.eContents().get(3);
		
		//Simulation:
		//	GaussianSlewLimited | ConstantQuantity | DeterministicSignal | RuntimeSpecifiedWaveform;
		@Override public ParserRule getRule() { return rule; }
		
		//GaussianSlewLimited | ConstantQuantity | DeterministicSignal | RuntimeSpecifiedWaveform
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//GaussianSlewLimited
		public RuleCall getGaussianSlewLimitedParserRuleCall_0() { return cGaussianSlewLimitedParserRuleCall_0; }
		
		//ConstantQuantity
		public RuleCall getConstantQuantityParserRuleCall_1() { return cConstantQuantityParserRuleCall_1; }
		
		//DeterministicSignal
		public RuleCall getDeterministicSignalParserRuleCall_2() { return cDeterministicSignalParserRuleCall_2; }
		
		//RuntimeSpecifiedWaveform
		public RuleCall getRuntimeSpecifiedWaveformParserRuleCall_3() { return cRuntimeSpecifiedWaveformParserRuleCall_3; }
	}
	public class BehaviourElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.Behaviour");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cInputTransformParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cSideEffectsParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		private final RuleCall cOutputReturnParserRuleCall_2 = (RuleCall)cAlternatives.eContents().get(2);
		
		//Behaviour:
		//	InputTransform | SideEffects | OutputReturn;
		@Override public ParserRule getRule() { return rule; }
		
		//InputTransform | SideEffects | OutputReturn
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//InputTransform
		public RuleCall getInputTransformParserRuleCall_0() { return cInputTransformParserRuleCall_0; }
		
		//SideEffects
		public RuleCall getSideEffectsParserRuleCall_1() { return cSideEffectsParserRuleCall_1; }
		
		//OutputReturn
		public RuleCall getOutputReturnParserRuleCall_2() { return cOutputReturnParserRuleCall_2; }
	}
	public class CommandSimulationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.CommandSimulation");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cCommandSimulationAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cCommandKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cPogoCommandAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final CrossReference cPogoCommandCommandCrossReference_2_0 = (CrossReference)cPogoCommandAssignment_2.eContents().get(0);
		private final RuleCall cPogoCommandCommandQualifiedNameParserRuleCall_2_0_1 = (RuleCall)cPogoCommandCommandCrossReference_2_0.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cBehaviorTypeAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final RuleCall cBehaviorTypeBehaviourParserRuleCall_4_0 = (RuleCall)cBehaviorTypeAssignment_4.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_5 = (Keyword)cGroup.eContents().get(5);
		
		//CommandSimulation:
		//	{CommandSimulation}
		//	'Command' pogoCommand=[pogoDsl::Command|QualifiedName]
		//	'{'
		//	behaviorType=Behaviour?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//{CommandSimulation} 'Command' pogoCommand=[pogoDsl::Command|QualifiedName] '{' behaviorType=Behaviour? '}'
		public Group getGroup() { return cGroup; }
		
		//{CommandSimulation}
		public Action getCommandSimulationAction_0() { return cCommandSimulationAction_0; }
		
		//'Command'
		public Keyword getCommandKeyword_1() { return cCommandKeyword_1; }
		
		//pogoCommand=[pogoDsl::Command|QualifiedName]
		public Assignment getPogoCommandAssignment_2() { return cPogoCommandAssignment_2; }
		
		//[pogoDsl::Command|QualifiedName]
		public CrossReference getPogoCommandCommandCrossReference_2_0() { return cPogoCommandCommandCrossReference_2_0; }
		
		//QualifiedName
		public RuleCall getPogoCommandCommandQualifiedNameParserRuleCall_2_0_1() { return cPogoCommandCommandQualifiedNameParserRuleCall_2_0_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_3() { return cLeftCurlyBracketKeyword_3; }
		
		//behaviorType=Behaviour?
		public Assignment getBehaviorTypeAssignment_4() { return cBehaviorTypeAssignment_4; }
		
		//Behaviour
		public RuleCall getBehaviorTypeBehaviourParserRuleCall_4_0() { return cBehaviorTypeBehaviourParserRuleCall_4_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_5() { return cRightCurlyBracketKeyword_5; }
	}
	public class DataSimulationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.DataSimulation");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cDataSimulationAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cAttributeKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cPogoAttrAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final CrossReference cPogoAttrAttributeCrossReference_2_0 = (CrossReference)cPogoAttrAssignment_2.eContents().get(0);
		private final RuleCall cPogoAttrAttributeQualifiedNameParserRuleCall_2_0_1 = (RuleCall)cPogoAttrAttributeCrossReference_2_0.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Keyword cData_Simulation_AlgorithmKeyword_4 = (Keyword)cGroup.eContents().get(4);
		private final Assignment cSimulationTypeAssignment_5 = (Assignment)cGroup.eContents().get(5);
		private final RuleCall cSimulationTypeSimulationParserRuleCall_5_0 = (RuleCall)cSimulationTypeAssignment_5.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_6 = (Keyword)cGroup.eContents().get(6);
		
		//DataSimulation:
		//	{DataSimulation}
		//	'Attribute' pogoAttr=[pogoDsl::Attribute|QualifiedName]?
		//	'{'
		//	'data_Simulation_Algorithm' simulationType=Simulation?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//{DataSimulation} 'Attribute' pogoAttr=[pogoDsl::Attribute|QualifiedName]? '{' 'data_Simulation_Algorithm'
		//simulationType=Simulation? '}'
		public Group getGroup() { return cGroup; }
		
		//{DataSimulation}
		public Action getDataSimulationAction_0() { return cDataSimulationAction_0; }
		
		//'Attribute'
		public Keyword getAttributeKeyword_1() { return cAttributeKeyword_1; }
		
		//pogoAttr=[pogoDsl::Attribute|QualifiedName]?
		public Assignment getPogoAttrAssignment_2() { return cPogoAttrAssignment_2; }
		
		//[pogoDsl::Attribute|QualifiedName]
		public CrossReference getPogoAttrAttributeCrossReference_2_0() { return cPogoAttrAttributeCrossReference_2_0; }
		
		//QualifiedName
		public RuleCall getPogoAttrAttributeQualifiedNameParserRuleCall_2_0_1() { return cPogoAttrAttributeQualifiedNameParserRuleCall_2_0_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_3() { return cLeftCurlyBracketKeyword_3; }
		
		//'data_Simulation_Algorithm'
		public Keyword getData_Simulation_AlgorithmKeyword_4() { return cData_Simulation_AlgorithmKeyword_4; }
		
		//simulationType=Simulation?
		public Assignment getSimulationTypeAssignment_5() { return cSimulationTypeAssignment_5; }
		
		//Simulation
		public RuleCall getSimulationTypeSimulationParserRuleCall_5_0() { return cSimulationTypeSimulationParserRuleCall_5_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_6() { return cRightCurlyBracketKeyword_6; }
	}
	public class GaussianSlewLimitedElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.GaussianSlewLimited");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cGaussianSlewLimitedAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cGaussianSlewLimitedKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Keyword cMinBoundKeyword_3_0 = (Keyword)cGroup_3.eContents().get(0);
		private final Assignment cMinBoundAssignment_3_1 = (Assignment)cGroup_3.eContents().get(1);
		private final RuleCall cMinBoundEFloatParserRuleCall_3_1_0 = (RuleCall)cMinBoundAssignment_3_1.eContents().get(0);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cMaxBoundKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cMaxBoundAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final RuleCall cMaxBoundEFloatParserRuleCall_4_1_0 = (RuleCall)cMaxBoundAssignment_4_1.eContents().get(0);
		private final Group cGroup_5 = (Group)cGroup.eContents().get(5);
		private final Keyword cMeanKeyword_5_0 = (Keyword)cGroup_5.eContents().get(0);
		private final Assignment cMeanAssignment_5_1 = (Assignment)cGroup_5.eContents().get(1);
		private final RuleCall cMeanEFloatParserRuleCall_5_1_0 = (RuleCall)cMeanAssignment_5_1.eContents().get(0);
		private final Group cGroup_6 = (Group)cGroup.eContents().get(6);
		private final Keyword cSlewRateKeyword_6_0 = (Keyword)cGroup_6.eContents().get(0);
		private final Assignment cSlewRateAssignment_6_1 = (Assignment)cGroup_6.eContents().get(1);
		private final RuleCall cSlewRateEFloatParserRuleCall_6_1_0 = (RuleCall)cSlewRateAssignment_6_1.eContents().get(0);
		private final Group cGroup_7 = (Group)cGroup.eContents().get(7);
		private final Keyword cUpdatePeriodKeyword_7_0 = (Keyword)cGroup_7.eContents().get(0);
		private final Assignment cUpdatePeriodAssignment_7_1 = (Assignment)cGroup_7.eContents().get(1);
		private final RuleCall cUpdatePeriodEFloatParserRuleCall_7_1_0 = (RuleCall)cUpdatePeriodAssignment_7_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_8 = (Keyword)cGroup.eContents().get(8);
		
		//GaussianSlewLimited:
		//	{GaussianSlewLimited}
		//	'GaussianSlewLimited'
		//	'{' ('minBound' minBound=EFloat)? ('maxBound' maxBound=EFloat)? ('mean' mean=EFloat)? ('slewRate' slewRate=EFloat)?
		//	('updatePeriod' updatePeriod=EFloat)?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//{GaussianSlewLimited} 'GaussianSlewLimited' '{' ('minBound' minBound=EFloat)? ('maxBound' maxBound=EFloat)? ('mean'
		//mean=EFloat)? ('slewRate' slewRate=EFloat)? ('updatePeriod' updatePeriod=EFloat)? '}'
		public Group getGroup() { return cGroup; }
		
		//{GaussianSlewLimited}
		public Action getGaussianSlewLimitedAction_0() { return cGaussianSlewLimitedAction_0; }
		
		//'GaussianSlewLimited'
		public Keyword getGaussianSlewLimitedKeyword_1() { return cGaussianSlewLimitedKeyword_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//('minBound' minBound=EFloat)?
		public Group getGroup_3() { return cGroup_3; }
		
		//'minBound'
		public Keyword getMinBoundKeyword_3_0() { return cMinBoundKeyword_3_0; }
		
		//minBound=EFloat
		public Assignment getMinBoundAssignment_3_1() { return cMinBoundAssignment_3_1; }
		
		//EFloat
		public RuleCall getMinBoundEFloatParserRuleCall_3_1_0() { return cMinBoundEFloatParserRuleCall_3_1_0; }
		
		//('maxBound' maxBound=EFloat)?
		public Group getGroup_4() { return cGroup_4; }
		
		//'maxBound'
		public Keyword getMaxBoundKeyword_4_0() { return cMaxBoundKeyword_4_0; }
		
		//maxBound=EFloat
		public Assignment getMaxBoundAssignment_4_1() { return cMaxBoundAssignment_4_1; }
		
		//EFloat
		public RuleCall getMaxBoundEFloatParserRuleCall_4_1_0() { return cMaxBoundEFloatParserRuleCall_4_1_0; }
		
		//('mean' mean=EFloat)?
		public Group getGroup_5() { return cGroup_5; }
		
		//'mean'
		public Keyword getMeanKeyword_5_0() { return cMeanKeyword_5_0; }
		
		//mean=EFloat
		public Assignment getMeanAssignment_5_1() { return cMeanAssignment_5_1; }
		
		//EFloat
		public RuleCall getMeanEFloatParserRuleCall_5_1_0() { return cMeanEFloatParserRuleCall_5_1_0; }
		
		//('slewRate' slewRate=EFloat)?
		public Group getGroup_6() { return cGroup_6; }
		
		//'slewRate'
		public Keyword getSlewRateKeyword_6_0() { return cSlewRateKeyword_6_0; }
		
		//slewRate=EFloat
		public Assignment getSlewRateAssignment_6_1() { return cSlewRateAssignment_6_1; }
		
		//EFloat
		public RuleCall getSlewRateEFloatParserRuleCall_6_1_0() { return cSlewRateEFloatParserRuleCall_6_1_0; }
		
		//('updatePeriod' updatePeriod=EFloat)?
		public Group getGroup_7() { return cGroup_7; }
		
		//'updatePeriod'
		public Keyword getUpdatePeriodKeyword_7_0() { return cUpdatePeriodKeyword_7_0; }
		
		//updatePeriod=EFloat
		public Assignment getUpdatePeriodAssignment_7_1() { return cUpdatePeriodAssignment_7_1; }
		
		//EFloat
		public RuleCall getUpdatePeriodEFloatParserRuleCall_7_1_0() { return cUpdatePeriodEFloatParserRuleCall_7_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_8() { return cRightCurlyBracketKeyword_8; }
	}
	public class ConstantQuantityElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.ConstantQuantity");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cConstantQuantityAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cConstantQuantityKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Keyword cInitialValueKeyword_3_0 = (Keyword)cGroup_3.eContents().get(0);
		private final Assignment cInitialValueAssignment_3_1 = (Assignment)cGroup_3.eContents().get(1);
		private final RuleCall cInitialValueEFloatParserRuleCall_3_1_0 = (RuleCall)cInitialValueAssignment_3_1.eContents().get(0);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cQualityKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cQualityAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final RuleCall cQualityEFloatParserRuleCall_4_1_0 = (RuleCall)cQualityAssignment_4_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_5 = (Keyword)cGroup.eContents().get(5);
		
		//ConstantQuantity:
		//	{ConstantQuantity}
		//	'ConstantQuantity'
		//	'{' ('initialValue' initialValue=EFloat)? ('quality' quality=EFloat)?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//{ConstantQuantity} 'ConstantQuantity' '{' ('initialValue' initialValue=EFloat)? ('quality' quality=EFloat)? '}'
		public Group getGroup() { return cGroup; }
		
		//{ConstantQuantity}
		public Action getConstantQuantityAction_0() { return cConstantQuantityAction_0; }
		
		//'ConstantQuantity'
		public Keyword getConstantQuantityKeyword_1() { return cConstantQuantityKeyword_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//('initialValue' initialValue=EFloat)?
		public Group getGroup_3() { return cGroup_3; }
		
		//'initialValue'
		public Keyword getInitialValueKeyword_3_0() { return cInitialValueKeyword_3_0; }
		
		//initialValue=EFloat
		public Assignment getInitialValueAssignment_3_1() { return cInitialValueAssignment_3_1; }
		
		//EFloat
		public RuleCall getInitialValueEFloatParserRuleCall_3_1_0() { return cInitialValueEFloatParserRuleCall_3_1_0; }
		
		//('quality' quality=EFloat)?
		public Group getGroup_4() { return cGroup_4; }
		
		//'quality'
		public Keyword getQualityKeyword_4_0() { return cQualityKeyword_4_0; }
		
		//quality=EFloat
		public Assignment getQualityAssignment_4_1() { return cQualityAssignment_4_1; }
		
		//EFloat
		public RuleCall getQualityEFloatParserRuleCall_4_1_0() { return cQualityEFloatParserRuleCall_4_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_5() { return cRightCurlyBracketKeyword_5; }
	}
	public class DeterministicSignalElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.DeterministicSignal");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cDeterministicSignalAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cDeterministicSignalKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Keyword cTypeKeyword_3_0 = (Keyword)cGroup_3.eContents().get(0);
		private final Assignment cTypeAssignment_3_1 = (Assignment)cGroup_3.eContents().get(1);
		private final RuleCall cTypeEStringParserRuleCall_3_1_0 = (RuleCall)cTypeAssignment_3_1.eContents().get(0);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cAmplitudeKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cAmplitudeAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final RuleCall cAmplitudeEFloatParserRuleCall_4_1_0 = (RuleCall)cAmplitudeAssignment_4_1.eContents().get(0);
		private final Group cGroup_5 = (Group)cGroup.eContents().get(5);
		private final Keyword cPeriodKeyword_5_0 = (Keyword)cGroup_5.eContents().get(0);
		private final Assignment cPeriodAssignment_5_1 = (Assignment)cGroup_5.eContents().get(1);
		private final RuleCall cPeriodEIntParserRuleCall_5_1_0 = (RuleCall)cPeriodAssignment_5_1.eContents().get(0);
		private final Group cGroup_6 = (Group)cGroup.eContents().get(6);
		private final Keyword cOffsetKeyword_6_0 = (Keyword)cGroup_6.eContents().get(0);
		private final Assignment cOffsetAssignment_6_1 = (Assignment)cGroup_6.eContents().get(1);
		private final RuleCall cOffsetEFloatParserRuleCall_6_1_0 = (RuleCall)cOffsetAssignment_6_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_7 = (Keyword)cGroup.eContents().get(7);
		
		//DeterministicSignal:
		//	{DeterministicSignal}
		//	'DeterministicSignal'
		//	'{' ('type' type=EString)? ('amplitude' amplitude=EFloat)? ('period' period=EInt)? ('offset' offset=EFloat)?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//{DeterministicSignal} 'DeterministicSignal' '{' ('type' type=EString)? ('amplitude' amplitude=EFloat)? ('period'
		//period=EInt)? ('offset' offset=EFloat)? '}'
		public Group getGroup() { return cGroup; }
		
		//{DeterministicSignal}
		public Action getDeterministicSignalAction_0() { return cDeterministicSignalAction_0; }
		
		//'DeterministicSignal'
		public Keyword getDeterministicSignalKeyword_1() { return cDeterministicSignalKeyword_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//('type' type=EString)?
		public Group getGroup_3() { return cGroup_3; }
		
		//'type'
		public Keyword getTypeKeyword_3_0() { return cTypeKeyword_3_0; }
		
		//type=EString
		public Assignment getTypeAssignment_3_1() { return cTypeAssignment_3_1; }
		
		//EString
		public RuleCall getTypeEStringParserRuleCall_3_1_0() { return cTypeEStringParserRuleCall_3_1_0; }
		
		//('amplitude' amplitude=EFloat)?
		public Group getGroup_4() { return cGroup_4; }
		
		//'amplitude'
		public Keyword getAmplitudeKeyword_4_0() { return cAmplitudeKeyword_4_0; }
		
		//amplitude=EFloat
		public Assignment getAmplitudeAssignment_4_1() { return cAmplitudeAssignment_4_1; }
		
		//EFloat
		public RuleCall getAmplitudeEFloatParserRuleCall_4_1_0() { return cAmplitudeEFloatParserRuleCall_4_1_0; }
		
		//('period' period=EInt)?
		public Group getGroup_5() { return cGroup_5; }
		
		//'period'
		public Keyword getPeriodKeyword_5_0() { return cPeriodKeyword_5_0; }
		
		//period=EInt
		public Assignment getPeriodAssignment_5_1() { return cPeriodAssignment_5_1; }
		
		//EInt
		public RuleCall getPeriodEIntParserRuleCall_5_1_0() { return cPeriodEIntParserRuleCall_5_1_0; }
		
		//('offset' offset=EFloat)?
		public Group getGroup_6() { return cGroup_6; }
		
		//'offset'
		public Keyword getOffsetKeyword_6_0() { return cOffsetKeyword_6_0; }
		
		//offset=EFloat
		public Assignment getOffsetAssignment_6_1() { return cOffsetAssignment_6_1; }
		
		//EFloat
		public RuleCall getOffsetEFloatParserRuleCall_6_1_0() { return cOffsetEFloatParserRuleCall_6_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_7() { return cRightCurlyBracketKeyword_7; }
	}
	public class RuntimeSpecifiedWaveformElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.RuntimeSpecifiedWaveform");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cRuntimeSpecifiedWaveformAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cRuntimeSpecifiedWaveformKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Keyword cDefaultValueKeyword_3_0 = (Keyword)cGroup_3.eContents().get(0);
		private final Assignment cDefaultValueAssignment_3_1 = (Assignment)cGroup_3.eContents().get(1);
		private final RuleCall cDefaultValueEFloatParserRuleCall_3_1_0 = (RuleCall)cDefaultValueAssignment_3_1.eContents().get(0);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cTimestampKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cTimestampAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final RuleCall cTimestampEStringParserRuleCall_4_1_0 = (RuleCall)cTimestampAssignment_4_1.eContents().get(0);
		private final Group cGroup_5 = (Group)cGroup.eContents().get(5);
		private final Keyword cAttribute_qualitiesKeyword_5_0 = (Keyword)cGroup_5.eContents().get(0);
		private final Assignment cAttribute_qualitiesAssignment_5_1 = (Assignment)cGroup_5.eContents().get(1);
		private final RuleCall cAttribute_qualitiesEFloatParserRuleCall_5_1_0 = (RuleCall)cAttribute_qualitiesAssignment_5_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_6 = (Keyword)cGroup.eContents().get(6);
		
		//RuntimeSpecifiedWaveform:
		//	{RuntimeSpecifiedWaveform}
		//	'RuntimeSpecifiedWaveform'
		//	'{' ('defaultValue' defaultValue=EFloat)? ('timestamp' timestamp=EString)? ('attribute_qualities'
		//	attribute_qualities=EFloat)?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//{RuntimeSpecifiedWaveform} 'RuntimeSpecifiedWaveform' '{' ('defaultValue' defaultValue=EFloat)? ('timestamp'
		//timestamp=EString)? ('attribute_qualities' attribute_qualities=EFloat)? '}'
		public Group getGroup() { return cGroup; }
		
		//{RuntimeSpecifiedWaveform}
		public Action getRuntimeSpecifiedWaveformAction_0() { return cRuntimeSpecifiedWaveformAction_0; }
		
		//'RuntimeSpecifiedWaveform'
		public Keyword getRuntimeSpecifiedWaveformKeyword_1() { return cRuntimeSpecifiedWaveformKeyword_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//('defaultValue' defaultValue=EFloat)?
		public Group getGroup_3() { return cGroup_3; }
		
		//'defaultValue'
		public Keyword getDefaultValueKeyword_3_0() { return cDefaultValueKeyword_3_0; }
		
		//defaultValue=EFloat
		public Assignment getDefaultValueAssignment_3_1() { return cDefaultValueAssignment_3_1; }
		
		//EFloat
		public RuleCall getDefaultValueEFloatParserRuleCall_3_1_0() { return cDefaultValueEFloatParserRuleCall_3_1_0; }
		
		//('timestamp' timestamp=EString)?
		public Group getGroup_4() { return cGroup_4; }
		
		//'timestamp'
		public Keyword getTimestampKeyword_4_0() { return cTimestampKeyword_4_0; }
		
		//timestamp=EString
		public Assignment getTimestampAssignment_4_1() { return cTimestampAssignment_4_1; }
		
		//EString
		public RuleCall getTimestampEStringParserRuleCall_4_1_0() { return cTimestampEStringParserRuleCall_4_1_0; }
		
		//('attribute_qualities' attribute_qualities=EFloat)?
		public Group getGroup_5() { return cGroup_5; }
		
		//'attribute_qualities'
		public Keyword getAttribute_qualitiesKeyword_5_0() { return cAttribute_qualitiesKeyword_5_0; }
		
		//attribute_qualities=EFloat
		public Assignment getAttribute_qualitiesAssignment_5_1() { return cAttribute_qualitiesAssignment_5_1; }
		
		//EFloat
		public RuleCall getAttribute_qualitiesEFloatParserRuleCall_5_1_0() { return cAttribute_qualitiesEFloatParserRuleCall_5_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_6() { return cRightCurlyBracketKeyword_6; }
	}
	public class EStringElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.EString");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cSTRINGTerminalRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cIDTerminalRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//EString:
		//	STRING | ID;
		@Override public ParserRule getRule() { return rule; }
		
		//STRING | ID
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//STRING
		public RuleCall getSTRINGTerminalRuleCall_0() { return cSTRINGTerminalRuleCall_0; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_1() { return cIDTerminalRuleCall_1; }
	}
	public class EFloatElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.EFloat");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cHyphenMinusKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final RuleCall cINTTerminalRuleCall_1 = (RuleCall)cGroup.eContents().get(1);
		private final Keyword cFullStopKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final RuleCall cINTTerminalRuleCall_3 = (RuleCall)cGroup.eContents().get(3);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Alternatives cAlternatives_4_0 = (Alternatives)cGroup_4.eContents().get(0);
		private final Keyword cEKeyword_4_0_0 = (Keyword)cAlternatives_4_0.eContents().get(0);
		private final Keyword cEKeyword_4_0_1 = (Keyword)cAlternatives_4_0.eContents().get(1);
		private final Keyword cHyphenMinusKeyword_4_1 = (Keyword)cGroup_4.eContents().get(1);
		private final RuleCall cINTTerminalRuleCall_4_2 = (RuleCall)cGroup_4.eContents().get(2);
		
		//EFloat ecore::EFloat:
		//	'-'? INT? '.' INT (('E' | 'e') '-'? INT)?;
		@Override public ParserRule getRule() { return rule; }
		
		//'-'? INT? '.' INT (('E' | 'e') '-'? INT)?
		public Group getGroup() { return cGroup; }
		
		//'-'?
		public Keyword getHyphenMinusKeyword_0() { return cHyphenMinusKeyword_0; }
		
		//INT?
		public RuleCall getINTTerminalRuleCall_1() { return cINTTerminalRuleCall_1; }
		
		//'.'
		public Keyword getFullStopKeyword_2() { return cFullStopKeyword_2; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_3() { return cINTTerminalRuleCall_3; }
		
		//(('E' | 'e') '-'? INT)?
		public Group getGroup_4() { return cGroup_4; }
		
		//'E' | 'e'
		public Alternatives getAlternatives_4_0() { return cAlternatives_4_0; }
		
		//'E'
		public Keyword getEKeyword_4_0_0() { return cEKeyword_4_0_0; }
		
		//'e'
		public Keyword getEKeyword_4_0_1() { return cEKeyword_4_0_1; }
		
		//'-'?
		public Keyword getHyphenMinusKeyword_4_1() { return cHyphenMinusKeyword_4_1; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_4_2() { return cINTTerminalRuleCall_4_2; }
	}
	public class EIntElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.EInt");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cHyphenMinusKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final RuleCall cINTTerminalRuleCall_1 = (RuleCall)cGroup.eContents().get(1);
		
		//EInt ecore::EInt:
		//	'-'? INT;
		@Override public ParserRule getRule() { return rule; }
		
		//'-'? INT
		public Group getGroup() { return cGroup; }
		
		//'-'?
		public Keyword getHyphenMinusKeyword_0() { return cHyphenMinusKeyword_0; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_1() { return cINTTerminalRuleCall_1; }
	}
	public class InputTransformElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.InputTransform");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cInputTransformAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cInputTransformKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Keyword cDestinationVariableNameKeyword_3_0 = (Keyword)cGroup_3.eContents().get(0);
		private final Assignment cDestinationVariableNameAssignment_3_1 = (Assignment)cGroup_3.eContents().get(1);
		private final RuleCall cDestinationVariableNameEStringParserRuleCall_3_1_0 = (RuleCall)cDestinationVariableNameAssignment_3_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_4 = (Keyword)cGroup.eContents().get(4);
		
		//InputTransform:
		//	{InputTransform}
		//	'InputTransform'
		//	'{' ('destinationVariableName' destinationVariableName=EString)?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//{InputTransform} 'InputTransform' '{' ('destinationVariableName' destinationVariableName=EString)? '}'
		public Group getGroup() { return cGroup; }
		
		//{InputTransform}
		public Action getInputTransformAction_0() { return cInputTransformAction_0; }
		
		//'InputTransform'
		public Keyword getInputTransformKeyword_1() { return cInputTransformKeyword_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//('destinationVariableName' destinationVariableName=EString)?
		public Group getGroup_3() { return cGroup_3; }
		
		//'destinationVariableName'
		public Keyword getDestinationVariableNameKeyword_3_0() { return cDestinationVariableNameKeyword_3_0; }
		
		//destinationVariableName=EString
		public Assignment getDestinationVariableNameAssignment_3_1() { return cDestinationVariableNameAssignment_3_1; }
		
		//EString
		public RuleCall getDestinationVariableNameEStringParserRuleCall_3_1_0() { return cDestinationVariableNameEStringParserRuleCall_3_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_4() { return cRightCurlyBracketKeyword_4; }
	}
	public class SideEffectsElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.SideEffects");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cSideEffectsAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cSideEffectsKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Keyword cSource_variableKeyword_3_0 = (Keyword)cGroup_3.eContents().get(0);
		private final Assignment cSource_variableAssignment_3_1 = (Assignment)cGroup_3.eContents().get(1);
		private final RuleCall cSource_variableEStringParserRuleCall_3_1_0 = (RuleCall)cSource_variableAssignment_3_1.eContents().get(0);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cDestination_quantityKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cDestination_quantityAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final RuleCall cDestination_quantityEStringParserRuleCall_4_1_0 = (RuleCall)cDestination_quantityAssignment_4_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_5 = (Keyword)cGroup.eContents().get(5);
		
		//SideEffects:
		//	{SideEffects}
		//	'SideEffects'
		//	'{' ('source_variable' source_variable=EString)? ('destination_quantity' destination_quantity=EString)?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//{SideEffects} 'SideEffects' '{' ('source_variable' source_variable=EString)? ('destination_quantity'
		//destination_quantity=EString)? '}'
		public Group getGroup() { return cGroup; }
		
		//{SideEffects}
		public Action getSideEffectsAction_0() { return cSideEffectsAction_0; }
		
		//'SideEffects'
		public Keyword getSideEffectsKeyword_1() { return cSideEffectsKeyword_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//('source_variable' source_variable=EString)?
		public Group getGroup_3() { return cGroup_3; }
		
		//'source_variable'
		public Keyword getSource_variableKeyword_3_0() { return cSource_variableKeyword_3_0; }
		
		//source_variable=EString
		public Assignment getSource_variableAssignment_3_1() { return cSource_variableAssignment_3_1; }
		
		//EString
		public RuleCall getSource_variableEStringParserRuleCall_3_1_0() { return cSource_variableEStringParserRuleCall_3_1_0; }
		
		//('destination_quantity' destination_quantity=EString)?
		public Group getGroup_4() { return cGroup_4; }
		
		//'destination_quantity'
		public Keyword getDestination_quantityKeyword_4_0() { return cDestination_quantityKeyword_4_0; }
		
		//destination_quantity=EString
		public Assignment getDestination_quantityAssignment_4_1() { return cDestination_quantityAssignment_4_1; }
		
		//EString
		public RuleCall getDestination_quantityEStringParserRuleCall_4_1_0() { return cDestination_quantityEStringParserRuleCall_4_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_5() { return cRightCurlyBracketKeyword_5; }
	}
	public class OutputReturnElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "com.mncml.implementation.pogo.SimulatorDsl.OutputReturn");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cOutputReturnAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cOutputReturnKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Keyword cSource_variableKeyword_3_0 = (Keyword)cGroup_3.eContents().get(0);
		private final Assignment cSource_variableAssignment_3_1 = (Assignment)cGroup_3.eContents().get(1);
		private final RuleCall cSource_variableEStringParserRuleCall_3_1_0 = (RuleCall)cSource_variableAssignment_3_1.eContents().get(0);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cSource_quantityKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cSource_quantityAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final RuleCall cSource_quantityEStringParserRuleCall_4_1_0 = (RuleCall)cSource_quantityAssignment_4_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_5 = (Keyword)cGroup.eContents().get(5);
		
		//OutputReturn:
		//	{OutputReturn}
		//	'OutputReturn'
		//	'{' ('source_variable' source_variable=EString)? ('source_quantity' source_quantity=EString)?
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//{OutputReturn} 'OutputReturn' '{' ('source_variable' source_variable=EString)? ('source_quantity'
		//source_quantity=EString)? '}'
		public Group getGroup() { return cGroup; }
		
		//{OutputReturn}
		public Action getOutputReturnAction_0() { return cOutputReturnAction_0; }
		
		//'OutputReturn'
		public Keyword getOutputReturnKeyword_1() { return cOutputReturnKeyword_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//('source_variable' source_variable=EString)?
		public Group getGroup_3() { return cGroup_3; }
		
		//'source_variable'
		public Keyword getSource_variableKeyword_3_0() { return cSource_variableKeyword_3_0; }
		
		//source_variable=EString
		public Assignment getSource_variableAssignment_3_1() { return cSource_variableAssignment_3_1; }
		
		//EString
		public RuleCall getSource_variableEStringParserRuleCall_3_1_0() { return cSource_variableEStringParserRuleCall_3_1_0; }
		
		//('source_quantity' source_quantity=EString)?
		public Group getGroup_4() { return cGroup_4; }
		
		//'source_quantity'
		public Keyword getSource_quantityKeyword_4_0() { return cSource_quantityKeyword_4_0; }
		
		//source_quantity=EString
		public Assignment getSource_quantityAssignment_4_1() { return cSource_quantityAssignment_4_1; }
		
		//EString
		public RuleCall getSource_quantityEStringParserRuleCall_4_1_0() { return cSource_quantityEStringParserRuleCall_4_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_5() { return cRightCurlyBracketKeyword_5; }
	}
	
	
	private final TangoSimLibElements pTangoSimLib;
	private final OverrideClassElements pOverrideClass;
	private final QualifiedNameElements pQualifiedName;
	private final SimulationElements pSimulation;
	private final BehaviourElements pBehaviour;
	private final CommandSimulationElements pCommandSimulation;
	private final DataSimulationElements pDataSimulation;
	private final GaussianSlewLimitedElements pGaussianSlewLimited;
	private final ConstantQuantityElements pConstantQuantity;
	private final DeterministicSignalElements pDeterministicSignal;
	private final RuntimeSpecifiedWaveformElements pRuntimeSpecifiedWaveform;
	private final EStringElements pEString;
	private final EFloatElements pEFloat;
	private final EIntElements pEInt;
	private final InputTransformElements pInputTransform;
	private final SideEffectsElements pSideEffects;
	private final OutputReturnElements pOutputReturn;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public SimulatorDslGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pTangoSimLib = new TangoSimLibElements();
		this.pOverrideClass = new OverrideClassElements();
		this.pQualifiedName = new QualifiedNameElements();
		this.pSimulation = new SimulationElements();
		this.pBehaviour = new BehaviourElements();
		this.pCommandSimulation = new CommandSimulationElements();
		this.pDataSimulation = new DataSimulationElements();
		this.pGaussianSlewLimited = new GaussianSlewLimitedElements();
		this.pConstantQuantity = new ConstantQuantityElements();
		this.pDeterministicSignal = new DeterministicSignalElements();
		this.pRuntimeSpecifiedWaveform = new RuntimeSpecifiedWaveformElements();
		this.pEString = new EStringElements();
		this.pEFloat = new EFloatElements();
		this.pEInt = new EIntElements();
		this.pInputTransform = new InputTransformElements();
		this.pSideEffects = new SideEffectsElements();
		this.pOutputReturn = new OutputReturnElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("com.mncml.implementation.pogo.SimulatorDsl".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//TangoSimLib:
	//	{TangoSimLib}
	//	'TangoSimLib' 'for' refferedPogoDeviceClass=[pogoDsl::PogoDeviceClass|QualifiedName]?
	//	'{' ('dataSimulations' '{' (dataSimulations+=DataSimulation (',' dataSimulations+=DataSimulation)*)?
	//	'}')? ('behaviours' '{' (commandSimulations+=CommandSimulation ("," commandSimulations+=CommandSimulation*))?
	//	'}')? ('override' '{' (overrideClass+=OverrideClass ',' overrideClass+=OverrideClass*)?
	//	'}')?
	//	'}';
	public TangoSimLibElements getTangoSimLibAccess() {
		return pTangoSimLib;
	}
	
	public ParserRule getTangoSimLibRule() {
		return getTangoSimLibAccess().getRule();
	}
	
	//OverrideClass:
	//	{OverrideClass}
	//	'OverrideClass' '{' ('name' name=STRING)? ('module_directory' module_directory=EString)? ('module_name'
	//	module_name=EString)? ('class_name' class_name=EString)?
	//	'}';
	public OverrideClassElements getOverrideClassAccess() {
		return pOverrideClass;
	}
	
	public ParserRule getOverrideClassRule() {
		return getOverrideClassAccess().getRule();
	}
	
	//QualifiedName:
	//	ID ('.' ID)*;
	public QualifiedNameElements getQualifiedNameAccess() {
		return pQualifiedName;
	}
	
	public ParserRule getQualifiedNameRule() {
		return getQualifiedNameAccess().getRule();
	}
	
	//Simulation:
	//	GaussianSlewLimited | ConstantQuantity | DeterministicSignal | RuntimeSpecifiedWaveform;
	public SimulationElements getSimulationAccess() {
		return pSimulation;
	}
	
	public ParserRule getSimulationRule() {
		return getSimulationAccess().getRule();
	}
	
	//Behaviour:
	//	InputTransform | SideEffects | OutputReturn;
	public BehaviourElements getBehaviourAccess() {
		return pBehaviour;
	}
	
	public ParserRule getBehaviourRule() {
		return getBehaviourAccess().getRule();
	}
	
	//CommandSimulation:
	//	{CommandSimulation}
	//	'Command' pogoCommand=[pogoDsl::Command|QualifiedName]
	//	'{'
	//	behaviorType=Behaviour?
	//	'}';
	public CommandSimulationElements getCommandSimulationAccess() {
		return pCommandSimulation;
	}
	
	public ParserRule getCommandSimulationRule() {
		return getCommandSimulationAccess().getRule();
	}
	
	//DataSimulation:
	//	{DataSimulation}
	//	'Attribute' pogoAttr=[pogoDsl::Attribute|QualifiedName]?
	//	'{'
	//	'data_Simulation_Algorithm' simulationType=Simulation?
	//	'}';
	public DataSimulationElements getDataSimulationAccess() {
		return pDataSimulation;
	}
	
	public ParserRule getDataSimulationRule() {
		return getDataSimulationAccess().getRule();
	}
	
	//GaussianSlewLimited:
	//	{GaussianSlewLimited}
	//	'GaussianSlewLimited'
	//	'{' ('minBound' minBound=EFloat)? ('maxBound' maxBound=EFloat)? ('mean' mean=EFloat)? ('slewRate' slewRate=EFloat)?
	//	('updatePeriod' updatePeriod=EFloat)?
	//	'}';
	public GaussianSlewLimitedElements getGaussianSlewLimitedAccess() {
		return pGaussianSlewLimited;
	}
	
	public ParserRule getGaussianSlewLimitedRule() {
		return getGaussianSlewLimitedAccess().getRule();
	}
	
	//ConstantQuantity:
	//	{ConstantQuantity}
	//	'ConstantQuantity'
	//	'{' ('initialValue' initialValue=EFloat)? ('quality' quality=EFloat)?
	//	'}';
	public ConstantQuantityElements getConstantQuantityAccess() {
		return pConstantQuantity;
	}
	
	public ParserRule getConstantQuantityRule() {
		return getConstantQuantityAccess().getRule();
	}
	
	//DeterministicSignal:
	//	{DeterministicSignal}
	//	'DeterministicSignal'
	//	'{' ('type' type=EString)? ('amplitude' amplitude=EFloat)? ('period' period=EInt)? ('offset' offset=EFloat)?
	//	'}';
	public DeterministicSignalElements getDeterministicSignalAccess() {
		return pDeterministicSignal;
	}
	
	public ParserRule getDeterministicSignalRule() {
		return getDeterministicSignalAccess().getRule();
	}
	
	//RuntimeSpecifiedWaveform:
	//	{RuntimeSpecifiedWaveform}
	//	'RuntimeSpecifiedWaveform'
	//	'{' ('defaultValue' defaultValue=EFloat)? ('timestamp' timestamp=EString)? ('attribute_qualities'
	//	attribute_qualities=EFloat)?
	//	'}';
	public RuntimeSpecifiedWaveformElements getRuntimeSpecifiedWaveformAccess() {
		return pRuntimeSpecifiedWaveform;
	}
	
	public ParserRule getRuntimeSpecifiedWaveformRule() {
		return getRuntimeSpecifiedWaveformAccess().getRule();
	}
	
	//EString:
	//	STRING | ID;
	public EStringElements getEStringAccess() {
		return pEString;
	}
	
	public ParserRule getEStringRule() {
		return getEStringAccess().getRule();
	}
	
	//EFloat ecore::EFloat:
	//	'-'? INT? '.' INT (('E' | 'e') '-'? INT)?;
	public EFloatElements getEFloatAccess() {
		return pEFloat;
	}
	
	public ParserRule getEFloatRule() {
		return getEFloatAccess().getRule();
	}
	
	//EInt ecore::EInt:
	//	'-'? INT;
	public EIntElements getEIntAccess() {
		return pEInt;
	}
	
	public ParserRule getEIntRule() {
		return getEIntAccess().getRule();
	}
	
	//InputTransform:
	//	{InputTransform}
	//	'InputTransform'
	//	'{' ('destinationVariableName' destinationVariableName=EString)?
	//	'}';
	public InputTransformElements getInputTransformAccess() {
		return pInputTransform;
	}
	
	public ParserRule getInputTransformRule() {
		return getInputTransformAccess().getRule();
	}
	
	//SideEffects:
	//	{SideEffects}
	//	'SideEffects'
	//	'{' ('source_variable' source_variable=EString)? ('destination_quantity' destination_quantity=EString)?
	//	'}';
	public SideEffectsElements getSideEffectsAccess() {
		return pSideEffects;
	}
	
	public ParserRule getSideEffectsRule() {
		return getSideEffectsAccess().getRule();
	}
	
	//OutputReturn:
	//	{OutputReturn}
	//	'OutputReturn'
	//	'{' ('source_variable' source_variable=EString)? ('source_quantity' source_quantity=EString)?
	//	'}';
	public OutputReturnElements getOutputReturnAccess() {
		return pOutputReturn;
	}
	
	public ParserRule getOutputReturnRule() {
		return getOutputReturnAccess().getRule();
	}
	
	//terminal ID:
	//	'^'? ('a'..'z' | 'A'..'Z' | '_') ('a'..'z' | 'A'..'Z' | '_' | '0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt:
	//	'0'..'9'+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//	'"' ('\\' . | !('\\' | '"'))* '"' | "'" ('\\' . | !('\\' | "'"))* "'";
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT:
	//	'/*'->'*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT:
	//	'//' !('\n' | '\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS:
	//	' ' | '\t' | '\r' | '\n'+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER:
	//	.;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
